/**
 * WorkSpace
 *
 * A canvas to display an Oct hierarchy
 *
 * @version $Id$
 * @author  Michael Shilman <michaels@eecs.berkeley.edu>
 */

import java.awt.*;
import java.util.Vector;
import java.util.Random;

public class WorkSpace extends Canvas {
    public OctCell m_design = null;
    public boolean m_display = false;
    public Vector netvector = new Vector(); 

    public WorkSpace() {
        super();
        setBackground(Color.black);
    //  display(true); 
    }
   
  /*   public WorkSpace(OctCell oc) {
        super();
        setBackground(Color.black);
        m_design = oc;
        display(true);
    } */
     public WorkSpace(OctCell oc) {
        super();
        setBackground(Color.black);
        m_design = oc;
    }

    public void setDesign(OctCell design) {
        m_design = design;
    }

    void display(boolean val) {
        m_display = val;
        repaint();
    }

    public void update(Graphics g) {
        paint(g);
    }

    public synchronized void paint(Graphics g) {
        int initx=0;
        int inity=0;
        int i=0;
        int j=0;
        OctView v = null;
       
        super.paint(g);
    //  System.out.println(m_design instanceof OctCell);
    //  System.out.println(m_design==null);
    //  System.out.println(i); 
         
        if(m_display) {
      
          // draw gates **************************************

           OctView ov = (OctView)m_design.contents.elementAt(0);     
           OctFacet of = (OctFacet)ov.contents.elementAt(0);
           while ( i < of.contents.size()){
             BasicCell bc = (BasicCell)of.contents.elementAt(i);
             for (int k=0;k<bc.contents.size();k++){
                OctObject obj = (OctObject)bc.contents.elementAt(k);
                if (obj instanceof OctBox) {
                   OctBox ob = (OctBox)obj;
                   OctPoint p1 = (OctPoint)obj.contents.elementAt(0);
                   draw_block(g, p1.x, p1.y,bc.name);
                }
               }
             i++; 
            }
          
         // draw nets ******************************************
           
           while (j < of.contents.size()){
             BasicCell bc = (BasicCell)of.contents.elementAt(j);
             //System.out.println("draw nets here");
             //System.out.println("Basic cell # "+j);
         //detect the position of the cell     

             OctBox ob = null;
             OctPoint op1 = null;
      //     System.out.println("hi, here"+bc.contents.isEmpty());
              
             op1 = op(bc);   
            //System.out.println("own position found "+op1.x+" "+op1.y);

         // traversing the data structre and every output terminal
         // can have two nets connected to them 
 
             OctTerm outterm = null;
             OctTerm term = null;
             for (int jj=0; jj<bc.contents.size();jj++){
                //System.out.println("jj "+jj);
                OctObject obj = (OctObject)bc.contents.elementAt(jj);
                if (obj instanceof OctTerm){
                    term = (OctTerm)obj;
                   if (term.name.equals("out")){
                     //System.out.println("out");
                     outterm = term;
                   }  
                    term = null;
                  }
                 }
             //System.out.println("outterm's name "+outterm.name);
              //System.out.println("outterm.contents.isEmpty "+outterm.contents.isEmpty());
              //System.out.println("enter draw Line phase"); 
              //System.out.println("size "+outterm.contents.size());

              //System.out.println("outterm contents size"+outterm.contents.size());   


           for (int kk=0; kk<outterm.contents.size();kk++){
                OctNet on = (OctNet)outterm.contents.elementAt(kk);
                //System.out.println("1, baby");
                for (int pp=0; pp<on.containers.size();pp++){
                   //System.out.println("octnet's container size"+on.containers.size());
            //     System.out.println("2, baby");
                   OctTerm ot = (OctTerm)on.containers.elementAt(pp);
            //     System.out.println("3, baby");
                   BasicCell bc2 = (BasicCell)ot.containers.elementAt(0);
            //     System.out.println("4, baby");
                   OctPoint op2 = op(bc2); 
            //     System.out.println("5, baby");  
                   if (ot.name.equals("in1")){
                     //System.out.println("a "+op1.x+"b "+op1.y+"c "+op2.x+"d "+op2.y);
                     draw_single_net(g,op1.x+30,op1.y+15,op2.x+10,op2.y+10);
                   }
                   if (ot.name.equals("in2")){
                     //System.out.println("a "+op1.x+"b "+op1.y+"c "+op2.x+"d "+op2.y);
                     draw_single_net(g,op1.x+30,op1.y+15,op2.x+10,op2.y+20);   
                   } 
                 }
             }
              j++;
           }  
         } 
         else super.paint(g);
    }
   public OctPoint op(BasicCell bc){
   
          OctBox ob = null;
          OctPoint op1 = null; 
          //System.out.println("op function called");
           for (int jj=0;jj<bc.contents.size();jj++){
           //     System.out.println("jj "+jj);
                OctObject obj = (OctObject)bc.contents.elementAt(jj);
          //    System.out.println("xxxxxxxxxx");
                if (obj instanceof OctBox){
          //         System.out.println("obj instanceof OctBox"+(obj instanceof OctBox));
                     ob = (OctBox) obj;
                     op1= (OctPoint)ob.contents.elementAt(0);
                 }
                   
                  // op1 = (OctPoint)ob.contents.elementAt(0); 
                }
           //System.out.println("a "+op1.x+"b "+op1.y);
           return op1;
      }


   public void draw_single_net(Graphics g,int x1,int y1,int x2,int y2){
        g.setColor(Color.blue);
        g.drawLine(x1,y1,x2,y2);          
    } 
  public void draw_block (Graphics g, int x, int y, String name) {
        g.setColor(Color.yellow);
        g.draw3DRect(10+x,10+y,20,10,true);
        //System.out.println("g.draw3DRect");
        g.setColor(Color.red);
        //System.out.println(" g.setColor(Color.red)");
        g.drawRoundRect(10+x,10+y,4,4,2,2);
        g.drawRoundRect(10+x,20+y,4,4,2,2);
        g.drawRoundRect(30+x,15+y,4,4,2,2);  
        Font f= new Font("TimesRoman", Font.PLAIN, 11);
        g.setColor(Color.pink); 
        FontMetrics fm = getFontMetrics(f);
        //System.out.println("drawString"); 
        g.setFont(f);
        g.drawString(name,x+12,y+20);
    }
}
