/**
 * HW1 Sample
 *
 * This file creates the main window and buttons,
 * and instantiates a WorkSpace to contain and
 * render the BasicCells.
 *
 * @version $Id$
 * @author  Michael Shilman <michaels@eecs.berkeley.edu>
 */

import java.awt.*;
import java.applet.*;
import java.util.Vector;
import java.util.Random;

public class hw1 extends Applet {

    static OctCell m_design = null;
    WorkSpace m_workSpace = null;
    Vector netvector = new Vector();
    /**
     * Create the GUI elements and
     * initialize the design
     */
    public void init() {
        Button button1,button2;
        super.init();
        //System.out.println("add workspace");
	setLayout(new BorderLayout());
        m_workSpace = new WorkSpace();
        add("Center", m_workSpace);
        Panel button_panel = new Panel();
        button_panel.setLayout(new FlowLayout());
        button_panel.add(button1 = new Button("Display Cell"));
        button_panel.add(button2 = new Button("Make Layout")); 
        add("South",button_panel);
        initDesign();
    }


    /**
     * Build the design, adding 100 BasicCell instances
     */
    void initDesign() {
        BasicCell instance_of_BaseCell= null; 
        //Initialize the BasicCell master
        BasicCell.initClass();

        //Initialize the design
        m_design = new OctCell("Design", "password1", "R");
      
        add_instance(100,m_design); 

        attachNets(m_design);
        makeLayout();
    }
    void add_instance(int index,OctCell oc ){
        
        OctCell env = oc;
        OctTransform transform; 
      //String name = "cell "+i;
        String view = "m_view";
        String master = "m_master";
        String facet  = "contents";
        int version = OCT.CURRENT_VERSION;
        BasicCell instance_of_BasicCell;
        
        OctView m_view = new OctView(oc,"Jimmy Jackson"); 
        oc.Attach(m_view);
        OctFacet m_facet = new OctFacet(oc, "m_design","m_view","m_facet",OCT.CURRENT_VERSION, OCT.APPEND);
        m_view.Attach(m_facet); 
        //System.out.println("add_instance");
        transform = new OctTransform(env);
        for (int i=0; i<index; i++){
          //System.out.println("add_instance"); 
           instance_of_BasicCell = new BasicCell(env,transform,"c "+i,master,view,facet,version);
           m_facet.Attach(instance_of_BasicCell);
        }
        m_workSpace.m_design= m_design;
       } 
    /**
     * get basiccell from my_design
     */
    public BasicCell importBasicCell(int index, OctCell oc) { 
        
        //System.out.println("importBasicCell"); 
        OctView ov = (OctView)oc.contents.elementAt(0);
        OctFacet of = (OctFacet)ov.contents.elementAt(0);
        BasicCell bc = (BasicCell)of.contents.elementAt(index);
        return bc;
     }
   
    public OctTerm getTerm(String name, int index) {
       
        BasicCell bc = importBasicCell(index,m_design);
         //System.out.println("OctTerm");
        for (int i = 0; i < bc.contents.size(); i++) {
            OctObject obj = (OctObject)bc.contents.elementAt(i);
            if(obj instanceof OctTerm) {
                OctTerm term = (OctTerm)obj;
                if(term.name.compareTo(name) == 0) {
                   //System.out.println("Term found: name = " + term.name);
                    BasicCell BC = (BasicCell) term.containers.elementAt(0);
                    //System.out.println("name of the cell is "+ BC.name); 
                    return term;
                }
            }
        }
         //System.out.println("getTerm");
        return null;
    }
    /**
     * Randomly attach all the nets.
     */
    void attachNets(OctCell oc /*Vector netvector*/) { 
      Vector ins = new Vector(200);

      for(int i = 0; i < 100; i++) {
            ins.addElement(getTerm("in1", i));
            ins.addElement(getTerm("in2", i));
        }

      Vector outs = new Vector(100);
      for(int i = 0; i < 100; i++) {
          outs.addElement(getTerm("out", i));
      }

      Random myRand = new Random();
   // Vector netvector = new Vector();
      
   // System.out.println("attachNets");  
  
      for (int i=0; i<100; i++){ 
          
         // each net may connect at least 3 terminal //
         // one of them is output , the others are inputs//
         // System.out.println("attachNets");
            OctNet net = new OctNet(oc,"net "+i,1);
            OctTerm ot = (OctTerm)outs.elementAt(i);
            ot.Attach(net);
         for (int j=0; j<(3+(int)(myRand.nextFloat()*3)); j++)
           {
            OctTerm ot1 = (OctTerm)ins.elementAt((int)(myRand.nextFloat()*200));  
            ot1.Attach(net);
           }
            //netvector.addElement(net);
         }
     for (int i=100; i<300; i++){
          OctNet net = new OctNet(oc,"net "+i, 1);
          OctTerm ot1= (OctTerm)outs.elementAt((int)(myRand.nextFloat()*100));
          OctTerm ot2= (OctTerm)ins.elementAt(i-100);
      //  System.out.println("attachNets"); 
          ot1.Attach(net);
          ot2.Attach(net);
        }
       //System.out.println("Finish attachNets"); 
     }
    /**
     * Traverse the design and position all the cells randomly
     */
    public void makeLayout(){
        m_design = new_oc(m_design);
    } 


    public OctCell new_oc(OctCell oc){
        int i = 0;
        Random myRandom = new Random();  
        //System.out.print("here, baby");
        OctPoint[] position = new OctPoint[100];


   //   pos = pos(50+(int)(myRandom.nextFloat()*20*10));
     
        position = pos(30);
        OctView  ov = (OctView)m_design.contents.elementAt(0);
        OctFacet of = (OctFacet)ov.contents.elementAt(0);
        
        while (i < of.contents.size()){
           //System.out.println("makeLayout");
           BasicCell bc=(BasicCell)of.contents.elementAt(i);
           //System.out.println("BasicCell bc=(BasicCell)of.contents.elementAt(i)");
           for (int k=0;k<bc.contents.size();k++){
              OctObject obj = (OctObject)bc.contents.elementAt(k);
             // System.out.println("OctObject obj = (OctObject)bc.contents.elementAt(k)");
              if (obj instanceof OctBox) {
                OctBox ob = (OctBox)obj;
            //  OctPoint p1 = (OctPoint)ob.contents.elementAt(0);
            //  p1.x = position[i].x;
            //  p1.y = position[i].y;
                if (ob.contents.isEmpty()){ 
                OctPoint p1 = new OctPoint(m_design,position[i].x,position[i].y); 
            //  OctPoint p2 = (OctPoint)ob.contents.elementAt(1);
            //  p2.x = p1.x+40;
            //  p2.y = p1.y+30;
                OctPoint p2 = new OctPoint(m_design,position[i].x+40,position[i].y+30);
                ob.Attach(p1);
                ob.Attach(p2);
                }
                else{
                OctPoint p1 = (OctPoint)ob.contents.elementAt(0);
                p1.x = position[i].x;
                p1.y = position[i].y;
                OctPoint p2 = (OctPoint)ob.contents.elementAt(1);
                p2.x = p1.x+40;
                p2.y = p1.y+30;
                }
              }
            }
         i++;
        }
        return m_design;
    } 
   
   // define a array with 100 components. each component has unique 
   // cordinate in the 10* 10 grid


    public OctPoint[] pos(int swap_amount){        
          
             OctPoint[] op = new OctPoint[100];  
             Random randy = new Random(); 

        for (int j=0; j < 10 ; j++) {
            for (int i=0 ; i < 10; i++) {
             //System.out.println("assign postion");
             op[i*10+j]=new OctPoint(m_design,i*40,j*30);
            }
         }
       for (int k=0; k<swap_amount;k++){
            //System.out.println("swapping");
            int a1 = (int)(randy.nextFloat()*100);
            int b1 = (int)(randy.nextFloat()*100);
            swap(op[a1],op[b1]);
            //System.out.println(a1+" "+b1);
         }
        return op;               
     }
   public void swap(OctPoint a, OctPoint b){
        
       OctPoint temp = new OctPoint(m_design,0,0);
       temp.x=a.x;
       a.x = b.x;
       b.x = temp.x; 
       temp.y = a.y;
       a.y = b.y;
       b.y = temp.y;
   }

    public boolean action(Event e, Object obj){
       if (e.target instanceof Button) {
         String label = (String) obj;
         
         if (label.equals("Display Cell")) {

          makeLayout();
          m_workSpace.display(true); 
          return true;
         }
         if (label.equals("Make Layout")) {
          makeLayout();
          m_workSpace.display(true);
          return true; 
          }

        }
     return false;
    }
  }
